
#include <time.h>
#include <fcntl.h>
#include <sys/stat.h>
#include <mqueue.h>


class Tachyon
{
   char      queue_name[255];
   mqd_t     msg_queue;
   int       msg_sequence;

   timespec  offset;
   timespec  T0;

   double    accelleration;


public:

   Tachyon();
   Tachyon(const char *name);
   ~Tachyon();
   const char * name(void);

   void expect_message(void);
   void receive_message(void);

   time_t   time(void);
   timespec gettime(void);

   int nanosleep(struct timespec req);
   int nanosleep(float req);
   int sleep_until(timespec ends_at);

   void settime(time_t sec);
   void accellerate(double factor);
};

//  Operations on timespec structures

timespec operator + (timespec a, timespec b);
timespec operator - (timespec a, timespec b);

bool operator < (timespec a, timespec b);
