#include <sys/types.h>
#include <unistd.h>
#include <signal.h>

#include <iostream>
#include "Tachyon.h"

/*
 *  Test the sleep function with signal handling
 *  By default, sleep 4 times 6 seconds.
 *  The sleep can be interrupted by a HUP signal, which is caught by a signal handler.
 */


// Signal handler for SIGHUP

void sighup_handler(int sig)
{
   std::cout << "Caught signal " << sig << "\n";
}

int main()
{

   Tachyon timebase;
   float interval;

   interval = 6.0;

   signal(SIGHUP, sighup_handler);

   std::cout << "PID = " << getpid() << "\n";
   std::cout << "Tachyon name is " << timebase.name() << "\n";
   std::cout.flush();
   for (int i = 0; i < 4; i++)
   {
      timebase.nanosleep(interval);
      std::cout << "6 seconds.\n";
   }
}
