#include <iostream>
#include "Tachyon.h"
#include "assert.h"

/*   test timespec operators  */

bool operator_test(timespec a, timespec b, timespec exp_add, timespec exp_sub, bool exp_lt)
{
   bool ok;

   ok = true;

   timespec add = a + b;
   timespec sub = a - b;
   bool     lt  = a < b;

   std::cout << a.tv_sec << "." << a.tv_nsec << " + " << b.tv_sec << "." << b.tv_nsec;
   std::cout << " = " << add.tv_sec << "." << add.tv_nsec <<  "\n";
   std::cout << a.tv_sec << "." << a.tv_nsec << " - " << b.tv_sec << "." << b.tv_nsec;
   std::cout << " = " << sub.tv_sec << "." << sub.tv_nsec <<  "\n";
   std::cout << a.tv_sec << "." << a.tv_nsec << " < " << b.tv_sec << "." << b.tv_nsec;
   std::cout << " = " << lt <<  "\n\n";
   std::cout.flush();

   ok = ok && add.tv_sec == exp_add.tv_sec && add.tv_nsec == exp_add.tv_nsec;
   ok = ok && sub.tv_sec == exp_sub.tv_sec && sub.tv_nsec == exp_sub.tv_nsec;
   ok = ok && lt == exp_lt;

   return ok;
}

int main()
{
   timespec t_add, t_sub;   // The expected values

   timespec ts0, ts1;

   ts0.tv_sec = 10;
   ts0.tv_nsec = 600000000;
   ts1.tv_sec = 2;
   ts1.tv_nsec = 500000000;

   t_add.tv_sec  = 13;
   t_add.tv_nsec = 100000000;
   t_sub.tv_sec  = 8;
   t_sub.tv_nsec = 100000000;

   assert(operator_test(ts0, ts1, t_add, t_sub, false));

   t_sub.tv_sec  = -8;
   t_sub.tv_nsec = -100000000;
   assert(operator_test(ts1, ts0, t_add, t_sub, true));

   timespec ts3, ts4;

   ts3.tv_sec = 10;
   ts3.tv_nsec = 600000000;
   ts4.tv_sec = 2;
   ts4.tv_nsec = 700000000;

   t_add.tv_sec  = 13;
   t_add.tv_nsec = 300000000;
   t_sub.tv_sec  = 7;
   t_sub.tv_nsec = 900000000;
   assert(operator_test(ts3, ts4, t_add, t_sub, false));

   t_sub.tv_sec  = -7;
   t_sub.tv_nsec = -900000000;
   assert(operator_test(ts4, ts3, t_add, t_sub, true));



   timespec ts6, ts7;

   ts6.tv_sec = 10;
   ts6.tv_nsec = 600000000;
   ts7.tv_sec = 10;
   ts7.tv_nsec = 600000999;

   t_add.tv_sec  = 21;
   t_add.tv_nsec = 200000999;
   t_sub.tv_sec  = 0;
   t_sub.tv_nsec = -999;
   assert(operator_test(ts6, ts7, t_add, t_sub, true));

}
